#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    vector<long long> a(n);
    vector<int> resenja(q);
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    for(int i=0;i<q;i++){
        int l,r;
        cin>>l>>r;
        l--;
        r--;
        int brmax=1;
        int br=1;
        vector<long long> b;
        for(int j=l;j<r;j++){
            b.push_back(a[j]);
        }
        sort(b.begin(), b.end());
        for(int j=l;j<=r-1;j++){
            if(b[j]==b[j+1]){
                br++;
            }else{
                if(brmax<br){
                    brmax=br;
                }
            }
        }
        if(brmax<br){
            brmax=br;
        }
        resenja[i]=brmax;
    }

    for(int i=0;i<q;i++){
        cout<<resenja[i]<<endl;
    }
    return 0;
}